unit UFrmWzrd;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, AfCmpWzrd, ExtCtrls, Buttons, ShellApi, Menus;

type
  TFrmWzrd = class(TForm)
    Notebook1: TNotebook;
    ComboBox1: TComboBox;
    Edit1: TEdit;
    ComboBox2: TComboBox;
    Edit2: TEdit;
    SpeedButton1: TSpeedButton;
    sd: TSaveDialog;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    cbAbout: TCheckBox;
    cbHeader: TCheckBox;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    Label5: TLabel;
    edAuthor: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    edVersion: TEdit;
    edDescription: TEdit;
    Label8: TLabel;
    edDate: TEdit;
    edemail: TEdit;
    edwebsite: TEdit;
    edabout: TEdit;
    SpeedButton4: TSpeedButton;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    SpeedButton5: TSpeedButton;
    Label12: TLabel;
    Label13: TLabel;
    cbedit: TCheckBox;
    SpeedButton6: TSpeedButton;
    Panel1: TPanel;
    rg: TRadioGroup;
    Label14: TLabel;
    Label15: TLabel;
    edCompoundClass: TEdit;
    edCompoundUnit: TEdit;
    edCompundUnit: TLabel;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    ComboBox3: TComboBox;
    Label16: TLabel;
    Label17: TLabel;
    edCompoundForm: TEdit;
    gbCompound: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    edOther: TEdit;
    rgIDE: TRadioGroup;
    cbCompoundHeader: TCheckBox;
    cbCompoundEdit: TCheckBox;
    cbCompoundAbout: TCheckBox;
    SpeedButton9: TSpeedButton;
    procedure ComboBox1Change(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure cbHeaderClick(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure SpeedButton2Click(Sender: TObject);
    procedure Notebook1PageChanged(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure edCompoundClassChange(Sender: TObject);
    procedure edCompoundUnitChange(Sender: TObject);
    procedure rgClick(Sender: TObject);
    procedure RadioButton4Click(Sender: TObject);
    procedure cbCompoundHeaderClick(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure SpeedButton9Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    FirstDir: string;
    function CreateFileName(WichText: string; Ext: Integer): string;
    procedure OpenForm(List, palettelist: TStrings; WichPalette, WichDir:
      string);
    procedure GenerateCode(Name: string; WithComment, WithAbout: Boolean);
  end;

var
  FrmWzrd: TFrmWzrd;

implementation

{$R *.dfm}

function TFrmWzrd.CreateFileName(WichText: string; Ext: Integer): string;
var
  slash, TheText: string;
begin
  result:= '';
  TheText:= WichText;
  if TheText <> '' then
  begin
    slash:= Copy(FirstDir, length(FirstDir), 1);
    if (TheText[1] = 't') or
      (TheText[1] = 'T') then
      delete(TheText, 1, 1);
    case Ext of
      0: result:= TheText + '.pas';
      1: result:= TheText + '.dfm';
    end;
    if slash <> '\' then
      result:= FirstDir + '\' + result
    else
      result:= FirstDir + result;
  end;
end;

procedure TFrmWzrd.OpenForm(List, palettelist: TStrings; WichPalette, WichDir:
  string);
var
  i: Integer;
begin
  ComboBox1.Items.AddStrings(List);
  ComboBox1.Sorted:= true;
  ComboBox2.Items.AddStrings(palettelist);
  ComboBox2.Sorted:= true;
  ComboBox3.Items.AddStrings(palettelist);
  ComboBox3.Sorted:= true;
  for i:= 0 to ComboBox2.Items.Count - 1 do
    if ComboBox2.Items[i] = WichPalette then
    begin
      ComboBox2.ItemIndex:= i;
      break;
    end;
  ComboBox3.ItemIndex:= ComboBox2.ItemIndex;
  FirstDir:= WichDir;
  edDate.Text:= DateToSTr(Date);
  ShowModal;
end;

procedure TFrmWzrd.ComboBox1Change(Sender: TObject);
begin
  if ComboBox1.Text <> '' then
    Edit1.Text:= ComboBox1.Text + '1'
  else
    Edit1.Text:= '';

end;

procedure TFrmWzrd.Edit1Change(Sender: TObject);

begin
  Edit2.Text:= CreateFileName(Edit1.Text, 0);
  SpeedButton2.enabled:= ((Edit1.Text <> '') and (ComboBox1.Text <> ''));
end;

procedure TFrmWzrd.SpeedButton1Click(Sender: TObject);
begin
  sd.InitialDir:= FirstDir;
  if sd.Execute then
  begin
    case rg.ItemIndex of
      0: Edit2.Text:= sd.FileName;
      1: edCompoundUnit.Text:= sd.FileName;
    end;
    FirstDir:= ExtractFileDir(sd.FileName);
  end;
end;

procedure TFrmWzrd.cbHeaderClick(Sender: TObject);
begin
  if not cbHeader.Checked then
    cbedit.Checked:= false;
  cbedit.enabled:= cbHeader.Checked;
end;

procedure TFrmWzrd.SpeedButton3Click(Sender: TObject);
begin
  Close;
end;

procedure TFrmWzrd.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    Key:= #0;
    Perform(CM_DialogKey, VK_TAB, 0);
  end;
end;

procedure TFrmWzrd.SpeedButton2Click(Sender: TObject);
begin
  if cbHeader.Checked then
    if cbedit.Checked then
      Notebook1.PageIndex:= 1
    else
      GenerateCode(Edit2.Text, true, cbAbout.Checked)
  else
    GenerateCode(Edit2.Text, false, cbAbout.Checked);
end;

procedure TFrmWzrd.Notebook1PageChanged(Sender: TObject);
var
  myList: TStrings;
begin
  if Notebook1.ActivePage = 'Comments' then
    if FileExists(ExtractFilePath(Application.ExeName) + 'Comments') then
    begin
      myList:= TStringList.Create;
      myList.LoadFromFile(ExtractFilePath(Application.ExeName) + 'Comments');
      edAuthor.Text:= myList[0];
      edVersion.Text:= myList[1];
      edDescription.Text:= myList[2];
      edemail.Text:= myList[3];
      edwebsite.Text:= myList[4];
      edabout.Text:= myList[5];
      myList.Free;
    end;
end;

procedure TFrmWzrd.SpeedButton5Click(Sender: TObject);
var
  myList: TStrings;
begin
  if MessageDlg('Confirm save comments?', mtConfirmation, [mbYes, mbNo], 0) =
    mrYes then
  begin
    myList:= TStringList.Create;
    myList.Add(edAuthor.Text);
    myList.Add(edVersion.Text);
    myList.Add(edDescription.Text);
    myList.Add(edemail.Text);
    myList.Add(edwebsite.Text);
    myList.Add(edabout.Text);
    myList.SaveToFile(ExtractFilePath(Application.ExeName) + 'Comments');
    myList.Free;
  end;
end;

procedure TFrmWzrd.GenerateCode(Name: string; WithComment, WithAbout: Boolean);
var
  myList, MyFormList: TStrings;
  UnitName, CompName: string;
  lm: TAFNewMenuItem;
  Compound: Boolean;
  function GetUnitName: string;
  begin
    result:= ExtractFileName(Name);
    while pos('.pas', result) > 0 do
      delete(result, pos('.pas', result), 4);
  end;
  function GetCompoundClass: string;
  begin
    if RadioButton1.Checked then
      result:= RadioButton1.Caption
    else if RadioButton2.Checked then
      result:= RadioButton2.Caption
    else if RadioButton3.Checked then
      result:= RadioButton3.Caption
    else
      result:= edOther.Text;
  end;
begin
  Compound:= rg.ItemIndex = 1;
  if Compound then
    CompName:= edCompoundClass.Text
  else
    CompName:= Edit1.Text;
  if FileExists(Name) then
    if MessageDlg('File ' + Name + ' already exists. Overwrite it?',
      mtConfirmation, [mbYes, mbNo], 0) = mrNo then
    begin
      ShowMessage('Component creation aborted!');
      exit;
    end;
  MyList:= TStringList.Create;
  UnitName:= GetUnitName + ';';
  MyList.Add('{');
  MyList.Add('---------------------------------------------------------------');
  MyList.Add('Code generated by AF Component Wizard');
  MyList.Add('AF Component Wizard 2002 AFComponents - Ferruccio Accalai');
  MyList.Add('Idea by MAS-CompMaker, 2000-2002 Mats Asplund http://go.to/mdp');
  MyList.Add('---------------------------------------------------------------');
  if WithComment then
  begin
    myList.Add('');
    myList.Add('Component Name: ' + CompName);
    myList.Add('        Author: ' + edAuthor.Text);
    myList.Add(' Creation Date: ' + edDate.Text);
    myList.Add('       Version: ' + edVersion.Text);
    myList.Add('   Description: ' + edDescription.Text);
    myList.Add('        E-mail: ' + edemail.Text);
    myList.Add('       Website: ' + edwebsite.Text);
    myList.Add('  Legal Issues: All rigths reserved ' + FormatDateTime('yyyy',
      (StrToDate(edDate.Text))) + ' by ' + edAuthor.Text);
    myList.Add('');
    myList.Add('');
    myList.Add('Usage:');
    myList.Add('  This software is provided ''as-is'', without any express or');
    myList.Add('  implied warranty.  In no event will the author be held liable');
    myList.Add('  for any  damages arising from the use of this software.');
    myList.Add('');
    myList.Add('  Permission is granted to anyone to use this software for any');
    myList.Add('  purpose, including commercial applications, and to alter it');
    myList.Add('  and redistribute it freely, subject to the following restrictions:');
    myList.Add('');
    myList.Add('  1. The origin of this software must not be misrepresented,');
    myList.Add('     you must not claim that you wrote the original software.');
    myList.Add('     If you use this software in a product, an acknowledgment');
    myList.Add('     in the product documentation would be appreciated but is');
    myList.Add('     not required.');
    myList.Add('');
    myList.Add('  2. Altered source versions must be plainly marked as such, and');
    myList.Add('     must not be misrepresented as being the original software.');
    myList.Add('');
    myList.Add('  3. This notice may not be removed or altered from any source');
    myList.Add('     distribution.');
    myList.Add('');
    myList.Add('  4. If you decide to use this software in any of your applications.');
    myList.Add('     Send me an EMail and tell me about it.');
    myList.Add('');
    myList.Add('Quick Reference:');
    if Compound then
      myList.Add('  ' + CompName + ' inherits from ' + GetCompoundClass)
    else
      myList.Add('  ' + CompName + ' inherits from ' + ComboBox1.Text);
    myList.Add('');
    myList.Add('  Key-Properties:');
    myList.Add('  (place your key-properties here)');
    myList.Add('');
    myList.Add('  Key-Events:');
    myList.Add('  (place your key-events here)');
    myList.Add('');
    myList.Add('  Key-Methods:');
    myList.Add('  (place your key-methods here)');
    myList.Add('');
    myList.Add('---------------------------------------------------------------');
  end;
  myList.Add('}');
  myList.Add('');
  myList.Add('unit ' + UnitName);
  myList.Add('');
  myList.Add('interface');
  myList.Add('');
  myList.Add('uses');
  if Compound then
  begin
    myList.Add('   SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,');
    myList.Add('   Forms, Dialogs, Compound, StdCtrls, ExtCtrls;');
  end
  else
    myList.Add('  Windows, Messages, SysUtils, Classes' +
      lm.AddUnit(ComboBox1.Text));
  myList.Add('');
  myList.Add('type');
  if Compound then
  begin
    case rgIDE.ItemIndex of
      0: myList.Add('  ' + edCompoundForm.Text + ' = Class(TForm)');
      1: myList.Add('  ' + edCompoundForm.Text + ' = Class(TCompoundForm)');
    end;
    myList.Add('end;');
    myList.Add('');
    myList.Add('  ' + CompName + ' = Class(' + GetCompoundClass + ')');
  end
  else
    myList.Add('  ' + CompName + ' = Class(' + ComboBox1.Text + ')');
  myList.Add('  private');
  myList.Add('    { Private declarations }');
  if Compound then
    myList.Add('     fForm: ' + edCompoundForm.Text + ';');
  if WithAbout then
  begin
    myList.Add('     fAbout: String;');
    myList.Add('     procedure SetAbout(Value: String);');
  end;
  myList.Add('  protected');
  myList.Add('    { Protected declarations }');
  myList.Add('  public');
  myList.Add('    { Public declarations }');
  myList.Add('     constructor Create(AOwner: TComponent); override;');
  myList.Add('     destructor Destroy; override;');
  myList.Add('  published');
  myList.Add('    { Published declarations }');
  if Compound then
    myList.Add('     property Form: ' + edCompoundForm.Text + ' read FForm;');
  if WithAbout then
    myList.Add('     property About: String read fAbout write SetAbout;');
  myList.Add('  end;');
  if Compound then
  begin
    myList.Add('');
    myList.Add('var');
    myList.Add('   ' + Copy(edCompoundForm.Text, 2, length(edCompoundForm.Text))
      + ': ' + edCompoundForm.Text + ';');
  end;
  myList.Add('');
  myList.Add('procedure Register;');
  myList.Add('');
  myList.Add('implementation');
  if Compound then
    myList.Add('{$R *.DFM}');
  myList.Add('');
  myList.Add('procedure Register;');
  myList.Add('begin');
  if Compound then
    myList.Add('  RegisterComponents(''' + ComboBox3.Text + ''', [' + CompName +
      ']);')
  else
    myList.Add('  RegisterComponents(''' + ComboBox2.Text + ''', [' + CompName +
      ']);');
  myList.Add('end;');
  myList.Add('');
  myList.Add('constructor ' + CompName + '.Create(AOwner: TComponent);');
  myList.Add('begin');
  myList.Add('  inherited Create(AOwner);');
  if Compound then
    myList.Add('  fForm:= MoveControls(' + edCompoundForm.Text +
      '.Create(nil));');
  if WithAbout then
    myList.Add('  fAbout := ''' + edabout.Text + ''';');
  myList.Add('end;');
  myList.Add('');
  myList.Add('destructor ' + CompName + '.Destroy;');
  myList.Add('begin');
  myList.Add('  inherited Destroy;');
  myList.Add('end;');
  myList.Add('');
  if WithAbout then
  begin
    myList.Add('procedure ' + CompName + '.SetAbout(Value: String);');
    myList.Add('begin');
    myList.Add('  Exit;');
    myList.Add('end;');
    myList.Add('');
  end;
  myList.Add('end.');

  myList.SaveToFile(Name);
  if Compound then
  begin
    MyFormList:= TStringList.Create;
    MyFormList.Add('object ' + Copy(edCompoundForm.Text, 2,
      length(edCompoundForm.Text)) + ': ' + edCompoundForm.Text);
    MyFormList.Add('  Left = 291');
    MyFormList.Add('  Top = 126');
    MyFormList.Add('  Width = 200');
    MyFormList.Add('  Height = 200');
    MyFormList.Add('  BorderStyle = bsNone');
    MyFormList.Add('  Caption = ''''');
    MyFormList.Add('  Color = clBtnFace');
    MyFormList.Add('  Font.Charset = DEFAULT_CHARSET');
    MyFormList.Add('  Font.Color = clWindowText');
    MyFormList.Add('  Font.Height = -11');
    MyFormList.Add('  Font.Name = ''MS Sans Serif''');
    MyFormList.Add('  Font.Style = []');
    MyFormList.Add('  OldCreateOrder = False');
    MyFormList.Add('  Position = poScreenCenter');
    MyFormList.Add('  Visible = False');
    MyFormList.Add('  PixelsPerInch = 96');
    MyFormList.Add('  TextHeight = 13');
    MyFormList.Add('end');
    MyFormList.SaveToFile(CreateFileName(CompName, 1));
    MyFormList.Free;
  end;
  ShellExecute(Application.Handle, 'open', PChar(Name), '', '', sw_ShowNormal);
  Close;
end;

procedure TFrmWzrd.SpeedButton6Click(Sender: TObject);
begin
  case rg.ItemIndex of
    0: Notebook1.PageIndex:= 0;
    1: Notebook1.PageIndex:= 2;
  end;
end;

procedure TFrmWzrd.edCompoundClassChange(Sender: TObject);
begin
  edCompoundUnit.Text:= CreateFileName(edCompoundClass.Text, 0);
  SpeedButton7.enabled:= ((edCompoundClass.Text <> '') and (edCompoundUnit.Text
    <> ''));
end;

procedure TFrmWzrd.edCompoundUnitChange(Sender: TObject);
begin
  SpeedButton7.enabled:= ((edCompoundClass.Text <> '') and
    (edCompoundUnit.Text <> '') and
    (edCompoundForm.Text <> ''));
end;

procedure TFrmWzrd.rgClick(Sender: TObject);
begin
  case rg.ItemIndex of
    0: Notebook1.PageIndex:= 0;
    1:
      begin
        Notebook1.PageIndex:= 2;
        edCompoundClassChange(self);
      end;
  end;
end;

procedure TFrmWzrd.RadioButton4Click(Sender: TObject);
begin
  edOther.Visible:= RadioButton4.Checked;
  if edOther.Visible then
    edOther.setfocus;
end;

procedure TFrmWzrd.cbCompoundHeaderClick(Sender: TObject);
begin
  if not cbCompoundHeader.Checked then
    cbCompoundEdit.Checked:= false;
  cbCompoundEdit.enabled:= cbCompoundHeader.Checked;
end;

procedure TFrmWzrd.SpeedButton7Click(Sender: TObject);
begin
  if cbCompoundHeader.Checked then
    if cbCompoundEdit.Checked then
      Notebook1.PageIndex:= 1
    else
      GenerateCode(edCompoundUnit.Text, true, cbCompoundAbout.Checked)
  else
    GenerateCode(edCompoundUnit.Text, false, cbCompoundAbout.Checked);
end;

procedure TFrmWzrd.SpeedButton9Click(Sender: TObject);
begin
  Close;
end;

procedure TFrmWzrd.SpeedButton4Click(Sender: TObject);
begin
  case rg.ItemIndex of
    0: GenerateCode(Edit2.Text, cbHeader.Checked, cbAbout.Checked);
    1: GenerateCode(edCompoundUnit.Text, cbCompoundHeader.Checked,
      cbCompoundAbout.Checked);
  end;
end;

end.

